package com.ruoyi.cai.controller.admin;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.cai.domain.AccountChangeLog;
import com.ruoyi.cai.dto.admin.CaiDictVo;
import com.ruoyi.cai.enums.account.AccountCateEnum;
import com.ruoyi.cai.service.AccountChangeLogService;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.page.TableDataInfo;
import lombok.RequiredArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.constraints.NotNull;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 账户明细
 *
 * @author 77
 * @date 2024-01-05
 */
@Validated
@RequiredArgsConstructor
@RestController
@RequestMapping("/cai/accountChangeLog")
public class AccountChangeLogController extends BaseController {

    private final AccountChangeLogService accountChangeLogService;

    @GetMapping("/listChangeType")
    public R<List<CaiDictVo>> listChangeType(){
        List<CaiDictVo> res = Arrays.stream(AccountCateEnum.values()).map(i -> {
            CaiDictVo vo = new CaiDictVo();
            vo.setValue(i.getCode() + "");
            vo.setLabel(i.getText());
            return vo;
        }).collect(Collectors.toList());
        return R.ok(res);
    }

    /**
     * 查询账户明细列表
     */
    @SaCheckPermission("cai:accountChangeLog:list")
    @GetMapping("/list")
    public TableDataInfo<AccountChangeLog> list(AccountChangeLog bo, PageQuery pageQuery) {
        Page<AccountChangeLog> page = accountChangeLogService.pageAdmin(pageQuery, bo);
        return TableDataInfo.build(page);
    }

    /**
     * 获取账户明细详细信息
     *
     * @param id 主键
     */
    @SaCheckPermission("cai:accountChangeLog:query")
    @GetMapping("/{id}")
    public R<AccountChangeLog> getInfo(@NotNull(message = "主键不能为空")
                                     @PathVariable Long id) {
        return R.ok(accountChangeLogService.getById(id));
    }

}
